#ifndef UKUIBLUR_H
#define UKUIBLUR_H

#include <QObject>
#include <KWayland/Client/region.h>
#include <KWayland/Client/event_queue.h>
#include <KWayland/Client/surface.h>
#include "ukui-blur-manager-client-protocol.h"

struct ukui_blur_manager_v1;
struct ukui_blur_surface_v1;
using namespace KWayland::Client;

class UkuiBlur : public QObject
{
    Q_OBJECT
public:
    explicit UkuiBlur(QObject *parent = nullptr);
    ~UkuiBlur();

    bool isValid() const;

    void release();

    void destroy();

    void setup(ukui_blur_surface_v1 *blur);

    void setRegion(Region *region);

    void setStrength(uint32_t strength);


    operator ukui_blur_surface_v1 *();
    operator ukui_blur_surface_v1 *() const;

private:
    class Private;
    QScopedPointer<Private> d;

};

class UkuiBlurManager : public QObject
{
    Q_OBJECT
public:
    explicit UkuiBlurManager(QObject *parent = nullptr);
    ~UkuiBlurManager();

    bool isValid() const;

    void release();

    void destroy();

    void setup(ukui_blur_manager_v1 *blur_manager);

    void setEventQueue(EventQueue *queue);

    EventQueue *eventQueue();

    UkuiBlur *createBlur(Surface *surface, QObject *parent = nullptr);

    void removeBlur(Surface *surface);

    operator ukui_blur_manager_v1 *();

    operator ukui_blur_manager_v1 *() const;

private:
    class Private;
    QScopedPointer<Private> d;

};

#endif // UKUIBLUR_H
